import { EventEmitter } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * Directive to close the modal gallery clicking on the semi-transparent background.
 * In fact, it listens for a click on all elements that aren't 'inside' and it emits
 * an event using `@Output clickOutside`.
 */
export declare class ClickOutsideDirective {
    /**
     * Boolean to enable this directive.
     */
    clickOutsideEnable: boolean | undefined;
    /**
     * Output to emit an event if the clicked element class doesn't contain 'inside' or it is 'hidden'. The payload is a boolean.
     */
    clickOutside: EventEmitter<boolean>;
    /**
     * Method called by Angular itself every click thanks to `@HostListener`.
     * @param event MouseEvent
     */
    onClick(event: MouseEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ClickOutsideDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ClickOutsideDirective, "[ksClickOutside]", never, { "clickOutsideEnable": { "alias": "clickOutsideEnable"; "required": false; }; }, { "clickOutside": "clickOutside"; }, never, never, false, never>;
}
