import { ElementRef, OnChanges, OnInit, Renderer2 } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * Directive to change the flex-direction of an element, based on two inputs (`direction` and `justify`).
 */
export declare class DirectionDirective implements OnInit, OnChanges {
    private renderer;
    private el;
    /**
     * String input to set the css flex-direction of an element.
     */
    direction: string | undefined;
    /**
     * String input to set the css justify-content of an element.
     */
    justify: string | undefined;
    constructor(renderer: Renderer2, el: ElementRef);
    /**
     * Method ´ngOnInit´ to apply the style of this directive.
     * This is an angular lifecycle hook, so its called automatically by Angular itself.
     * In particular, it's called only one time!!!
     */
    ngOnInit(): void;
    /**
     * Method ´ngOnChanges´ to apply the style of this directive.
     * This is an angular lifecycle hook, so its called automatically by Angular itself.
     * In particular, it's called when any data-bound property of a directive changes!!!
     */
    ngOnChanges(): void;
    /**
     * Private method to change both direction and justify of an element.
     */
    private applyStyle;
    static ɵfac: i0.ɵɵFactoryDeclaration<DirectionDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<DirectionDirective, "[ksDirection]", never, { "direction": { "alias": "direction"; "required": false; }; "justify": { "alias": "justify"; "required": false; }; }, {}, never, never, false, never>;
}
