import { ElementRef, OnChanges, OnInit, Renderer2 } from '@angular/core';
import { Size } from '../model/size.interface';
import * as i0 from "@angular/core";
/**
 * Directive to change the size of an element.
 */
export declare class SizeDirective implements OnInit, OnChanges {
    private renderer;
    private el;
    /**
     * Object of type `Size` to resize the element.
     */
    sizeConfig: Size | undefined;
    constructor(renderer: Renderer2, el: ElementRef);
    /**
     * Method ´ngOnInit´ to apply the style of this directive.
     * This is an Angular lifecycle hook, so its called automatically by Angular itself.
     * In particular, it's called only one time!!!
     */
    ngOnInit(): void;
    /**
     * Method ´ngOnChanges´ to apply the style of this directive.
     * This is an Angular lifecycle hook, so its called automatically by Angular itself.
     * In particular, it's called when any data-bound property of a directive changes!!!
     */
    ngOnChanges(): void;
    /**
     * Private method to change both width and height of an element.
     */
    private applyStyle;
    static ɵfac: i0.ɵɵFactoryDeclaration<SizeDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SizeDirective, "[ksSize]", never, { "sizeConfig": { "alias": "sizeConfig"; "required": false; }; }, {}, never, never, false, never>;
}
