import { EventEmitter } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * Directive to manage swipe events on touch devices.
 */
export declare class SwipeDirective {
    defaultTouch: {
        x: number;
        y: number;
        time: number;
    };
    /**
     * Output to emit swipe left event. Payload is empty.
     */
    swipeLeft: EventEmitter<void>;
    /**
     * Output to emit swipe right event. Payload is empty.
     */
    swipeRight: EventEmitter<void>;
    /**
     * Output to emit swipe up event. Payload is empty.
     */
    swipeUp: EventEmitter<void>;
    /**
     * Output to emit swipe down event. Payload is empty.
     */
    swipeDown: EventEmitter<void>;
    /**
     * Method called by Angular itself every click thanks to `@HostListener`.
     * @param event TouchEvent payload received on touch
     */
    handleTouch(event: TouchEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SwipeDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SwipeDirective, "[ksSwipe]", never, {}, { "swipeLeft": "swipeLeft"; "swipeRight": "swipeRight"; "swipeUp": "swipeUp"; "swipeDown": "swipeDown"; }, never, never, false, never>;
}
