import { SlideConfig } from './slide-config.interface';
import { AccessibilityConfig } from './accessibility.interface';
import { PreviewConfig } from './preview-config.interface';
import { ButtonsConfig } from './buttons-config.interface';
import { DotsConfig } from './dots-config.interface';
import { PlainGalleryConfig } from './plain-gallery-config.interface';
import { CurrentImageConfig } from './current-image-config.interface';
import { KeyboardConfig } from './keyboard-config.interface';
import { CarouselConfig } from './carousel-config.interface';
import { CarouselImageConfig } from './carousel-image-config.interface';
import { CarouselPreviewConfig } from './carousel-preview-config.interface';
import { PlayConfig } from './play-config.interface';
export interface AccessibleLibConfig {
    accessibilityConfig?: AccessibilityConfig;
}
export interface CommonLibConfig {
    previewConfig?: PreviewConfig;
    dotsConfig?: DotsConfig;
    slideConfig?: SlideConfig;
}
export interface CarouselLibConfig extends CommonLibConfig, AccessibleLibConfig {
    carouselConfig?: CarouselConfig;
    carouselImageConfig?: CarouselImageConfig;
    carouselPreviewsConfig?: CarouselPreviewConfig;
    carouselPlayConfig?: PlayConfig;
    carouselDotsConfig?: DotsConfig;
    carouselSlideInfinite?: boolean;
}
export interface ModalLibConfig extends CommonLibConfig, AccessibleLibConfig {
    enableCloseOutside?: boolean;
    keyboardConfig?: KeyboardConfig;
    currentImageConfig?: CurrentImageConfig;
    buttonsConfig?: ButtonsConfig;
}
export interface PlainLibConfig extends AccessibleLibConfig {
    plainGalleryConfig?: PlainGalleryConfig;
}
export interface LibConfig extends ModalLibConfig, PlainLibConfig, CarouselLibConfig {
}
